VTK: vtkPixelBufferObject Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkPixelBufferObject Class Reference

abstracts an OpenGL pixel buffer object. More...

`#include <vtkPixelBufferObject.h>`

Inheritance diagram for vtkPixelBufferObject:
[legend]
Collaboration diagram for vtkPixelBufferObject:
[legend]

## Public Types
enum | { StreamDraw = 0 , StreamRead , StreamCopy , StaticDraw , StaticRead , StaticCopy , DynamicDraw , DynamicRead , DynamicCopy , NumberOfUsages }
enum | BufferType { UNPACKED_BUFFER = 0 , PACKED_BUFFER }
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPixelBufferObject * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
bool | Upload3D (int type, void *data, unsigned int dims[3], int comps, vtkIdType increments[3], int components, int *componentList)
| Update data to PBO mapped sourcing it from a 3D array. More...
bool | Download3D (int type, void *data, unsigned int dims[3], int numcomps, vtkIdType increments[3])
| Download data from pixel buffer to the 3D array. More...
void | BindToPackedBuffer ()
| Convenience methods for binding. More...
void | BindToUnPackedBuffer ()
void | UnBind ()
| Deactivate the buffer. More...
void * | MapPackedBuffer ()
| Convenience api for mapping buffers to app address space. More...
void * | MapPackedBuffer (int type, unsigned int numtuples, int comps)
void * | MapPackedBuffer (unsigned int numbytes)
void * | MapUnpackedBuffer ()
void * | MapUnpackedBuffer (int type, unsigned int numtuples, int comps)
void * | MapUnpackedBuffer (unsigned int numbytes)
void | UnmapUnpackedBuffer ()
| Convenience api for unmapping buffers from app address space. More...
void | UnmapPackedBuffer ()
void | Bind (BufferType buffer)
| Make the buffer active. More...
void | UnmapBuffer (BufferType mode)
| Un-map the buffer from our address space, OpenGL can then use/reclaim the buffer contents. More...
void | Allocate (int vtkType, unsigned int numtuples, int comps, BufferType mode)
| Allocate PACKED/UNPACKED memory to hold numTuples*numComponents of vtkType. More...
void | Allocate (unsigned int nbytes, BufferType mode)
| Allocate PACKED/UNPACKED memory to hold nBytes of data. More...
void | ReleaseMemory ()
| Release the memory allocated without destroying the PBO handle. More...
void | SetContext (vtkRenderWindow *context)
| Get/Set the context. More...
vtkRenderWindow * | GetContext ()
| Get/Set the context. More...
virtual int | GetUsage ()
| Usage is a performance hint. More...
virtual void | SetUsage (int)
| Usage is a performance hint. More...
bool | Upload1D (int type, void *data, unsigned int numtuples, int comps, vtkIdType increment)
| Upload data to PBO mapped. More...
bool | Upload2D (int type, void *data, unsigned int dims[2], int comps, vtkIdType increments[2])
| Update data to PBO mapped sourcing it from a 2D array. More...
virtual int | GetType ()
| Get the type with which the data is loaded into the PBO mapped. More...
virtual void | SetType (int)
| Get the type with which the data is loaded into the PBO mapped. More...
virtual int | GetComponents ()
| Get the number of components used to initialize the buffer. More...
virtual void | SetComponents (int)
| Get the number of components used to initialize the buffer. More...
virtual unsigned int | GetSize ()
| Get the size of the data loaded into the PBO mapped memory. More...
virtual void | SetSize (unsigned int)
| Get the size of the data loaded into the PBO mapped memory. More...
void | SetSize (unsigned int nTups, int nComps)
| Get the size of the data loaded into the PBO mapped memory. More...
virtual unsigned int | GetHandle ()
| Get the openGL buffer handle. More...
bool | Download1D (int type, void *data, unsigned int dim, int numcomps, vtkIdType increment)
| Download data from pixel buffer to the 1D array. More...
bool | Download2D (int type, void *data, unsigned int dims[2], int numcomps, vtkIdType increments[2])
| Download data from pixel buffer to the 2D array. More...
void * | MapBuffer (int type, unsigned int numtuples, int comps, BufferType mode)
| Map the buffer to our addresspace. More...
void * | MapBuffer (unsigned int numbytes, BufferType mode)
| Map the buffer to our addresspace. More...
void * | MapBuffer (BufferType mode)
| Map the buffer to our addresspace. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkPixelBufferObject * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPixelBufferObject * | SafeDownCast (vtkObjectBase *o)
static bool | IsSupported (vtkRenderWindow *renWin)
| Returns if the context supports the required extensions. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPixelBufferObject ()
| ~vtkPixelBufferObject () override
bool | LoadRequiredExtensions (vtkRenderWindow *renWin)
| Loads all required OpenGL extensions. More...
void | CreateBuffer ()
| Create the pixel buffer object. More...
void | DestroyBuffer ()
| Destroys the pixel buffer object. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | Usage
unsigned int | BufferTarget
int | Type
int | Components
unsigned int | Size
vtkWeakPointer< vtkRenderWindow > | Context
unsigned int | Handle
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

abstracts an OpenGL pixel buffer object.

Provides low-level access to PBO mapped memory. Used to transfer raw data to/from PBO mapped memory and the application. Once data is transferred to the PBO it can then be transferred to the GPU (eg texture memory). Data may be uploaded from the application into a pixel buffer or downloaded from the pixel buffer to the application. The vtkTextureObject is used to transfer data from/to the PBO to/from texture memory on the GPU.

See also
  OpenGL Pixel Buffer Object Extension Spec (ARB_pixel_buffer_object): http://www.opengl.org/registry/specs/ARB/pixel_buffer_object.txt

Warning
  Since most PBO mapped don't support double format all double data is converted to float and then uploaded.

Definition at line 32 of file vtkPixelBufferObject.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkPixelBufferObject::Superclass

Definition at line 51 of file vtkPixelBufferObject.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
StreamDraw |
StreamRead |
StreamCopy |
StaticDraw |
StaticRead |
StaticCopy |
DynamicDraw |
DynamicRead |
DynamicCopy |
NumberOfUsages |

Definition at line 36 of file vtkPixelBufferObject.h.

## ◆ BufferType

enum vtkPixelBufferObject::BufferType

Enumerator
UNPACKED_BUFFER |
PACKED_BUFFER |

Definition at line 274 of file vtkPixelBufferObject.h.

## Constructor & Destructor Documentation

## ◆ vtkPixelBufferObject()

vtkPixelBufferObject::vtkPixelBufferObject | ( |  | ) |
| protected

## ◆ ~vtkPixelBufferObject()

vtkPixelBufferObject::~vtkPixelBufferObject | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkPixelBufferObject* vtkPixelBufferObject::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkPixelBufferObject::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPixelBufferObject::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkPixelBufferObject* vtkPixelBufferObject::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPixelBufferObject::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkPixelBufferObject* vtkPixelBufferObject::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPixelBufferObject::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ SetContext()

void vtkPixelBufferObject::SetContext | ( | vtkRenderWindow * | context | ) |

Get/Set the context.

Context must be a vtkOpenGLRenderWindow. This does not increase the reference count of the context to avoid reference loops. SetContext() may raise an error if the OpenGL context does not support the required OpenGL extensions.

## ◆ GetContext()

vtkRenderWindow* vtkPixelBufferObject::GetContext | ( |  | ) |

Get/Set the context.

Context must be a vtkOpenGLRenderWindow. This does not increase the reference count of the context to avoid reference loops. SetContext() may raise an error if the OpenGL context does not support the required OpenGL extensions.

## ◆ GetUsage()

virtual int vtkPixelBufferObject::GetUsage | ( |  | ) |
| virtual

Usage is a performance hint.

Valid values are:

- StreamDraw specified once by A, used few times S
- StreamRead specified once by R, queried a few times by A
- StreamCopy specified once by R, used a few times S
- StaticDraw specified once by A, used many times S
- StaticRead specified once by R, queried many times by A
- StaticCopy specified once by R, used many times S
- DynamicDraw respecified repeatedly by A, used many times S
- DynamicRead respecified repeatedly by R, queried many times by A
- DynamicCopy respecified repeatedly by R, used many times S A: the application S: as the source for GL drawing and image specification commands. R: reading data from the GL Initial value is StaticDraw, as in OpenGL spec.

## ◆ SetUsage()

virtual void vtkPixelBufferObject::SetUsage | ( | int |  | ) |
| virtual

Usage is a performance hint.

Valid values are:

- StreamDraw specified once by A, used few times S
- StreamRead specified once by R, queried a few times by A
- StreamCopy specified once by R, used a few times S
- StaticDraw specified once by A, used many times S
- StaticRead specified once by R, queried many times by A
- StaticCopy specified once by R, used many times S
- DynamicDraw respecified repeatedly by A, used many times S
- DynamicRead respecified repeatedly by R, queried many times by A
- DynamicCopy respecified repeatedly by R, used many times S A: the application S: as the source for GL drawing and image specification commands. R: reading data from the GL Initial value is StaticDraw, as in OpenGL spec.

## ◆ Upload1D()

bool vtkPixelBufferObject::Upload1D | ( | int | type,
|  | void * | data,
|  | unsigned int | numtuples,
|  | int | comps,
|  | vtkIdType | increment
| ) |  |
| inline

Upload data to PBO mapped.

The input data can be freed after this call. The data ptr is treated as an 1D array with the given number of tuples and given number of components in each tuple to be copied to the PBO mapped. increment is the offset added after the last component in each tuple is transferred. Look at the documentation for ContinuousIncrements in vtkImageData for details about how increments are specified.

Definition at line 98 of file vtkPixelBufferObject.h.

## ◆ Upload2D()

bool vtkPixelBufferObject::Upload2D | ( | int | type,
|  | void * | data,
|  | unsigned int | dims[2],
|  | int | comps,
|  | vtkIdType | increments[2]
| ) |  |
| inline

Update data to PBO mapped sourcing it from a 2D array.

The input data can be freed after this call. The data ptr is treated as a 2D array with increments indicating how to iterate over the data. Look at the documentation for ContinuousIncrements in vtkImageData for details about how increments are specified.

Definition at line 121 of file vtkPixelBufferObject.h.

## ◆ Upload3D()

bool vtkPixelBufferObject::Upload3D | ( | int | type,
|  | void * | data,
|  | unsigned int | dims[3],
|  | int | comps,
|  | vtkIdType | increments[3],
|  | int | components,
|  | int * | componentList
| ) |  |

Update data to PBO mapped sourcing it from a 3D array.

The input data can be freed after this call. The data ptr is treated as a 3D array with increments indicating how to iterate over the data. Look at the documentation for ContinuousIncrements in vtkImageData for details about how increments are specified.

## ◆ GetType()

virtual int vtkPixelBufferObject::GetType | ( |  | ) |
| virtual

Get the type with which the data is loaded into the PBO mapped.

eg. VTK_FLOAT for float32, VTK_CHAR for byte, VTK_UNSIGNED_CHAR for unsigned byte etc.

## ◆ SetType()

virtual void vtkPixelBufferObject::SetType | ( | int |  | ) |
| virtual

Get the type with which the data is loaded into the PBO mapped.

eg. VTK_FLOAT for float32, VTK_CHAR for byte, VTK_UNSIGNED_CHAR for unsigned byte etc.

## ◆ GetComponents()

virtual int vtkPixelBufferObject::GetComponents | ( |  | ) |
| virtual

Get the number of components used to initialize the buffer.

## ◆ SetComponents()

virtual void vtkPixelBufferObject::SetComponents | ( | int |  | ) |
| virtual

Get the number of components used to initialize the buffer.

## ◆ GetSize()

virtual unsigned int vtkPixelBufferObject::GetSize | ( |  | ) |
| virtual

Get the size of the data loaded into the PBO mapped memory.

Size is in the number of elements of the uploaded Type.

## ◆ SetSize() [1/2]

virtual void vtkPixelBufferObject::SetSize | ( | unsigned int |  | ) |
| virtual

Get the size of the data loaded into the PBO mapped memory.

Size is in the number of elements of the uploaded Type.

## ◆ SetSize() [2/2]

void vtkPixelBufferObject::SetSize | ( | unsigned int | nTups,
|  | int | nComps
| ) |  |

Get the size of the data loaded into the PBO mapped memory.

Size is in the number of elements of the uploaded Type.

## ◆ GetHandle()

virtual unsigned int vtkPixelBufferObject::GetHandle | ( |  | ) |
| virtual

Get the openGL buffer handle.

## ◆ Download1D()

bool vtkPixelBufferObject::Download1D | ( | int | type,
|  | void * | data,
|  | unsigned int | dim,
|  | int | numcomps,
|  | vtkIdType | increment
| ) |  |
| inline

Download data from pixel buffer to the 1D array.

The length of the array must be equal to the size of the data in the memory.

Definition at line 186 of file vtkPixelBufferObject.h.

## ◆ Download2D()

bool vtkPixelBufferObject::Download2D | ( | int | type,
|  | void * | data,
|  | unsigned int | dims[2],
|  | int | numcomps,
|  | vtkIdType | increments[2]
| ) |  |
| inline

Download data from pixel buffer to the 2D array.

(lengthx * lengthy) must be equal to the size of the data in the memory.

Definition at line 205 of file vtkPixelBufferObject.h.

## ◆ Download3D()

bool vtkPixelBufferObject::Download3D | ( | int | type,
|  | void * | data,
|  | unsigned int | dims[3],
|  | int | numcomps,
|  | vtkIdType | increments[3]
| ) |  |

Download data from pixel buffer to the 3D array.

(lengthx * lengthy * lengthz) must be equal to the size of the data in the memory.

## ◆ BindToPackedBuffer()

void vtkPixelBufferObject::BindToPackedBuffer | ( |  | ) |
| inline

Convenience methods for binding.

Definition at line 230 of file vtkPixelBufferObject.h.

## ◆ BindToUnPackedBuffer()

void vtkPixelBufferObject::BindToUnPackedBuffer | ( |  | ) |
| inline

Definition at line 232 of file vtkPixelBufferObject.h.

## ◆ UnBind()

void vtkPixelBufferObject::UnBind | ( |  | ) |

Deactivate the buffer.

## ◆ MapPackedBuffer() [1/3]

void* vtkPixelBufferObject::MapPackedBuffer | ( |  | ) |
| inline

Convenience api for mapping buffers to app address space.

See also MapBuffer.

Definition at line 243 of file vtkPixelBufferObject.h.

## ◆ MapPackedBuffer() [2/3]

void* vtkPixelBufferObject::MapPackedBuffer | ( | int | type,
|  | unsigned int | numtuples,
|  | int | comps
| ) |  |
| inline

Definition at line 245 of file vtkPixelBufferObject.h.

## ◆ MapPackedBuffer() [3/3]

void* vtkPixelBufferObject::MapPackedBuffer | ( | unsigned int | numbytes | ) |
| inline

Definition at line 250 of file vtkPixelBufferObject.h.

## ◆ MapUnpackedBuffer() [1/3]

void* vtkPixelBufferObject::MapUnpackedBuffer | ( |  | ) |
| inline

Definition at line 252 of file vtkPixelBufferObject.h.

## ◆ MapUnpackedBuffer() [2/3]

void* vtkPixelBufferObject::MapUnpackedBuffer | ( | int | type,
|  | unsigned int | numtuples,
|  | int | comps
| ) |  |
| inline

Definition at line 254 of file vtkPixelBufferObject.h.

## ◆ MapUnpackedBuffer() [3/3]

void* vtkPixelBufferObject::MapUnpackedBuffer | ( | unsigned int | numbytes | ) |
| inline

Definition at line 259 of file vtkPixelBufferObject.h.

## ◆ UnmapUnpackedBuffer()

void vtkPixelBufferObject::UnmapUnpackedBuffer | ( |  | ) |
| inline

Convenience api for unmapping buffers from app address space.

See also UnmapBuffer.

Definition at line 268 of file vtkPixelBufferObject.h.

## ◆ UnmapPackedBuffer()

void vtkPixelBufferObject::UnmapPackedBuffer | ( |  | ) |
| inline

Definition at line 270 of file vtkPixelBufferObject.h.

## ◆ Bind()

void vtkPixelBufferObject::Bind | ( | BufferType | buffer | ) |

Make the buffer active.

## ◆ MapBuffer() [1/3]

void* vtkPixelBufferObject::MapBuffer | ( | int | type,
|  | unsigned int | numtuples,
|  | int | comps,
|  | BufferType | mode
| ) |  |

Map the buffer to our addresspace.

Returns a pointer to the mapped memory for read/write access. If type, tuples and components are specified new buffer data will be allocated, else the current allocation is mapped. When finished call UnmapBuffer.

## ◆ MapBuffer() [2/3]

void* vtkPixelBufferObject::MapBuffer | ( | unsigned int | numbytes,
|  | BufferType | mode
| ) |  |

Map the buffer to our addresspace.

Returns a pointer to the mapped memory for read/write access. If type, tuples and components are specified new buffer data will be allocated, else the current allocation is mapped. When finished call UnmapBuffer.

## ◆ MapBuffer() [3/3]

void* vtkPixelBufferObject::MapBuffer | ( | BufferType | mode | ) |

Map the buffer to our addresspace.

Returns a pointer to the mapped memory for read/write access. If type, tuples and components are specified new buffer data will be allocated, else the current allocation is mapped. When finished call UnmapBuffer.

## ◆ UnmapBuffer()

void vtkPixelBufferObject::UnmapBuffer | ( | BufferType | mode | ) |

Un-map the buffer from our address space, OpenGL can then use/reclaim the buffer contents.

## ◆ Allocate() [1/2]

void vtkPixelBufferObject::Allocate | ( | int | vtkType,
|  | unsigned int | numtuples,
|  | int | comps,
|  | BufferType | mode
| ) |  |

Allocate PACKED/UNPACKED memory to hold numTuples*numComponents of vtkType.

## ◆ Allocate() [2/2]

void vtkPixelBufferObject::Allocate | ( | unsigned int | nbytes,
|  | BufferType | mode
| ) |  |

Allocate PACKED/UNPACKED memory to hold nBytes of data.

## ◆ ReleaseMemory()

void vtkPixelBufferObject::ReleaseMemory | ( |  | ) |

Release the memory allocated without destroying the PBO handle.

## ◆ IsSupported()

static bool vtkPixelBufferObject::IsSupported | ( | vtkRenderWindow * | renWin | ) |
| static

Returns if the context supports the required extensions.

Extension will be loaded when the context is set.

## ◆ LoadRequiredExtensions()

bool vtkPixelBufferObject::LoadRequiredExtensions | ( | vtkRenderWindow * | renWin | ) |
| protected

Loads all required OpenGL extensions.

Must be called every time a new context is set.

## ◆ CreateBuffer()

void vtkPixelBufferObject::CreateBuffer | ( |  | ) |
| protected

Create the pixel buffer object.

## ◆ DestroyBuffer()

void vtkPixelBufferObject::DestroyBuffer | ( |  | ) |
| protected

Destroys the pixel buffer object.

## Member Data Documentation

## ◆ Usage

int vtkPixelBufferObject::Usage
| protected

Definition at line 344 of file vtkPixelBufferObject.h.

## ◆ BufferTarget

unsigned int vtkPixelBufferObject::BufferTarget
| protected

Definition at line 345 of file vtkPixelBufferObject.h.

## ◆ Type

int vtkPixelBufferObject::Type
| protected

Definition at line 346 of file vtkPixelBufferObject.h.

## ◆ Components

int vtkPixelBufferObject::Components
| protected

Definition at line 347 of file vtkPixelBufferObject.h.

## ◆ Size

unsigned int vtkPixelBufferObject::Size
| protected

Definition at line 348 of file vtkPixelBufferObject.h.

## ◆ Context

vtkWeakPointer<vtkRenderWindow> vtkPixelBufferObject::Context
| protected

Definition at line 349 of file vtkPixelBufferObject.h.

## ◆ Handle

unsigned int vtkPixelBufferObject::Handle
| protected

Definition at line 350 of file vtkPixelBufferObject.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkPixelBufferObject.h